#ifndef	TWINSTAR_COROSYNC_H
#define	TWINSTAR_COROSYNC_H

#include <stdint.h>
#include <glib-object.h>

G_BEGIN_DECLS

#define TWINSTAR_TYPE_COROSYNC         (twinstar_corosync_get_type ())
#define TWINSTAR_COROSYNC(o)           (G_TYPE_CHECK_INSTANCE_CAST ((o), TWINSTAR_TYPE_COROSYNC, TwinstarCorosync))
#define TWINSTAR_COROSYNC_CLASS(k)     (G_TYPE_CHECK_CLASS_CAST((k), TWINSTAR_TYPE_COROSYNC, TwinstarCorosyncClass))
#define TWINSTAR_IS_COROSYNC(o)        (G_TYPE_CHECK_INSTANCE_TYPE ((o), TWINSTAR_TYPE_COROSYNC))
#define TWINSTAR_IS_COROSYNC_CLASS(k)  (G_TYPE_CHECK_CLASS_TYPE ((k), TWINSTAR_TYPE_COROSYNC))
#define TWINSTAR_COROSYNC_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), TWINSTAR_TYPE_COROSYNC, TwinstarCorosyncClass))

typedef struct TwinstarCorosyncPrivate TwinstarCorosyncPrivate;

typedef struct {
	GObject parent;
	TwinstarCorosyncPrivate *priv;
} TwinstarCorosync;

typedef struct {
	GObjectClass             parent_class;
} TwinstarCorosyncClass;

typedef enum {
	TWINSTAR_COROSYNC_ERROR_GENERAL,
	TWINSTAR_COROSYNC_NUM_ERRORS
} TwinstarCorosyncError;


#define	TWINSTAR_COROSYNC_ERROR		(twinstar_corosync_error_quark ())
#define	TWINSTAR_COROSYNC_TYPE_ERROR	(twinstar_corosync_error_get_type ())

GQuark	twinstar_corosync_error_quark	(void);
GType	twinstar_corosync_error_get_type	(void);

TwinstarCorosync *twinstar_corosync_new(GMainContext *mainctx);
uint32_t twinstar_corosync_local_nodeid(const void *context);
gboolean twinstar_corosync_set_agents(TwinstarCorosync *corosync, const char *agents_dir);

G_END_DECLS

#endif	/* TWINSTAR_COROSYNC_H */
